# library("quantmod")
# getSymbols("^GSPC")
# sp500<-GSPC[757:1414,]
# write.table(data.frame(sp500[,0],sp500), "sp500.dat") # not very good???
sp500 <- read.table("sp500.dat")

# library("quantmod")
# getSymbols("GS")
# gs<-GS[757:1414,]
# write.table(data.frame(gs[,0],gs), "goldmanSacks.dat") # not very good???
gs <- read.table("goldmanSacks.dat")

# getSymbols("F")
# ford<-F[757:1414,] # use the data in 2010 -- 10.08.2012 only 
# write.table(data.frame(ford[,0], ford), "ford.dat")
ford <- read.table("ford.dat")

# Add name "Data" in Line 1 in sp500.dat, then
D <- read.table("sp500.dates")
t <- D[,1]
D <- strptime(t, "%Y-%m-%d") #convert to POSIXlt (a date class)
D <- D[2:659]

ps.options(horizontal=F, width=4.8, height=5, pointsize=9)
postscript("Fig37.eps", onefile=F, print=F)
par(mar=c(3,3,3,1),mfrow=c(3,1), mgp=c(1.8,0.6,0))
plot(D, sp500[,6], type='l', xlab='', ylab='', main='Daily S&P500 index prices', col=2)
plot(D, gs[,6], type='l', xlab='', ylab='', main='Daily Goldman Sacks stock prices', col=4)
plot(D, ford[,6], type='l', xlab='', ylab='', main='Daily Ford stock prices', col=4)
dev.off()

 library(TSA)

D <- D[2:658]
ps.options(horizontal=F, width=4.8, height=5, pointsize=9)
postscript("Fig38.eps", onefile=F, print=F)
par(mar=c(3,3,3,1),mfrow=c(3,2), mgp=c(1.8,0.6,0))
plot(D, 100*diff(log(sp500[,6])), type='l', xlab='', ylab='', ylim=c(-8.5, 6.5), 
main='Daily returns of S&P500 index', col="blue")
spGARCH11 <- garch(100*diff(log(sp500[,6])), order=c(1,1))
# summary(spGARCH11)
resid.sp = spGARCH11$residuals
condiSTD <- 100*diff(log(sp500[,6]))/resid.sp
# condiSTD <- spGARCH11$fitted.value[,1]  # use the output directly
lines(D, 2*condiSTD, col="red")
lines(D, -2*condiSTD, col="red")
k.sp = kurtosis(resid.sp, na.rm=T)
df.sp = (6+4*k.sp)/k.sp
qqnorm(resid.sp, col=4)
qqline(resid.sp, col=2)

plot(D, 100*diff(log(gs[,6])), type='l', xlab='', ylab='', 
    main='Daily returns of Goldman Sacks stock', col=4)
gsGARCH11 <- garch(100*diff(log(gs[,6])), order=c(1,1))
# summary(gsGARCH11)
resid.gs = gsGARCH11$residuals
condiSTD <- 100*diff(log(gs[,6]))/resid.gs
lines(D, 2*condiSTD, col="red")
lines(D, -2*condiSTD, col="red")
qqnorm(resid.gs, col=4)
qqline(resid.gs, col=2)
k.gs = kurtosis(resid.gs, na.rm=T)
df.gs = (6+4*k.gs)/k.gs


plot(D, 100*diff(log(ford[,6])), type='l', xlab='', ylab='', 
    main='Daily returns of Ford stock', col=4)
# fordGARCH11 <- garch(100*diff(log(ford[,6])), order=c(1,1))
fordGARCH11 <- garch(diff(log(ford[,6])), order=c(1,1))
# summary(fordGARCH11)
resid.f = fordGARCH11$residuals
condiSTD <- 100*diff(log(ford[,6]))/resid.f
lines(D, 2*condiSTD, col="red")
lines(D, -2*condiSTD, col="red")
k.f = kurtosis(resid.f, na.rm=T)
df.f = (6+4*k.f)/k.f
qqnorm(resid.f, col=4)
qqline(resid.f, col=2)
dev.off()

x <- as.ts(spGARCH11$residuals[2:657])
y <- x*x
r <- acf(y, col=3)
r1 <- acf(abs(x), col=3)
x <- as.ts(gsGARCH11$residuals[2:657])
y <- x*x
r2 <- acf(y, col=3)
r3 <- acf(abs(x), col=3)
x <- as.ts(fordGARCH11$residuals[2:657])
y <- x*x
r4 <- acf(y, col=3)
r5 <- acf(abs(x), col=3)

ps.options(horizontal=F, width=4.8, height=5, pointsize=9)
postscript("Fig39.eps", onefile=F, print=F)
par(mar=c(3,3,3,1),mfrow=c(3,2), mgp=c(1.8,0.6,0))
plot(r, xlab='lag', ylab='ACF', main='Squared residuals for S&P 500', col=3)
plot(r1, xlab='lag', ylab='ACF', main='Absolute residuals for S&P 500',col=3)
plot(r2, xlab='lag', ylab='ACF', main='Squared residuals for Goldman Sachs', col=3)
plot(r3, xlab='lag', ylab='ACF', main='Absolute residuals for Goldman Sachs', col=3)
plot(r4, xlab='lag', ylab='ACF', main='Squared residuals for Ford', col=3)
plot(r5, xlab='lag', ylab='ACF', main='Absolute residuals for Ford', col=3)
dev.off()

